import { Component } from '@angular/core';

@Component({
  selector: '<%= selector %>',
  <% if(inlineTemplate) { %>template: `
    <nz-date-picker
      [ngModel]="datePicker"
      (ngModelChange)="onChange($event, 0)"
      [nzFormat]="dateFormat"
      [nzValueFormat]="dateFormat"
    ></nz-date-picker>
    <br />
    <nz-month-picker
      [ngModel]="monthPicker"
      (ngModelChange)="onChange($event, 1)"
      [nzFormat]="monthFormat"
      [nzValueFormat]="monthFormat"
    ></nz-month-picker>
    <br />
    <nz-range-picker
      [ngModel]="rangePicker"
      (ngModelChange)="onChange($event, 2)"
      [nzFormat]="dateFormat2"
      [nzValueFormat]="dateFormat2"
    ></nz-range-picker>
  `<% } else { %>templateUrl: './<%= dasherize(name) %>.component.html'<% } %>,
  <% if(inlineStyle) { %>styles: [`
      nz-date-picker,
      nz-month-picker,
      nz-range-picker,
      nz-week-picker {
        margin: 0 8px 12px 0;
      }
    `]<% } else { %>styleUrls: ['./<%= dasherize(name) %>.component.<%= style %>']<% } %>
})
export class <%= classify(name) %>Component {
  datePicker = '2019/02/26';
  monthPicker = new Date();
  rangePicker = [new Date(), new Date()];

  dateFormat = 'yyyy/MM/dd';
  monthFormat = 'yyyy:MM';
  dateFormat2 = 'yyyy-MM-dd hh:mm:ss';

  constructor() {}

  onChange(result: Date | string, type: number): void {
    switch (type) {
      case 0:
        console.log(result, this.datePicker);
        break;
      case 1:
        console.log(result, this.monthPicker);
        break;
      case 2:
        console.log(result, this.rangePicker);
        break;
    }
  }
}
